cos		= math.cos
sin		= math.sin
atan2	= math.atan2
abs		= math.abs
pi		= math.pi
tau		= math.pi*2
max		= math.max
min		= math.min
pow		= math.pow
sqrt	= math.sqrt
tan		= math.tan
floor	= math.floor
ceil	= math.ceil
random	= math.random
vector = {}

function vector.rotate(x, y, t) return x*cos(t) - y*sin(t), x*sin(t) + y*cos(t) end

function vector.length(x, y) return math.sqrt(x * x + y * y) end

function clamp(input, lo, hi) return min(max(input, lo), hi) end

function dist(x1,y1,x2,y2) return sqrt(pow(y2 - y1,2) + pow(x2 - x1,2)) end